Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

'--------------------------------------------------------
'
'      Module List- Or ComboBox RightAlign  3.2003
'
'      (c) peter.k.sauer@web.de
'--------------------------------------------------------
'      ausrichten einer List- oder Combobox rechtsbndig
'      lschen, neu schreiben geht schneller als Update
'--------------------------------------------------------

'Saven eines Fonts
Public Type FontSaveType
    FontName As String
    FontSize As Long
    FontBold As Boolean
    FontItalic As Boolean
    FontUnderline As Boolean
    FontStrikethru As Boolean
End Type

Public Sub BoxSetRightAlign(objDestination As Object, _
        objBox As Object, Optional DigitCount As Long = 0)
    'Alle Items in List- oder Combobox rechtsbndig ausrichten
    'ObjectDestination ist eine Form oder eine Picturebox, die fr die
    'Berechnung der Textbreite bentigt wird
    'objBox ist eine List- oder Combobox

    Dim ListCount As Long
    Dim i As Long
    Dim s() As String
    Dim FontSave As FontSaveType
    
    ListCount = objBox.ListCount
    objBox.Visible = False
    
    'Box Items in Array auslesen und dann lschen
    ReDim s(ListCount, 1)
    For i = 0 To ListCount - 1
        s(i, 0) = objBox.List(i)
        s(i, 1) = Str$(objBox.ItemData(i))
    Next
    objBox.Clear
    
    'Font objDestination save
    FontSaveFont objDestination, FontSave
    
    'Font der Box zuweisen
    FontSetFont objDestination, objBox
    
    'rechtsbndig ausgerichtet in Box neu abstellen
    For i = 0 To ListCount - 1
        objBox.AddItem BoxSetItemRightAlign(objDestination, _
                            objBox, s(i, 0), ListCount, DigitCount)
        objBox.ItemData(objBox.NewIndex) = Val(s(i, 1))
    Next
    
    'Restore Font
    FontRestoreFont objDestination, FontSave
    objBox.Visible = True
End Sub

Public Sub BoxSetRightAlignAddItem(objDestination As Object, _
        objBox As Object, NewItem As String, Optional ItemData As String = "", _
        Optional ListCount As Long = -1, Optional DigitCount As Long = 0)
    'einer List- oder Combobox einen Eintrag rechtsbndig hinzufgen

    Dim mListCount As Long
    Dim FontSave As FontSaveType

    If mListCount - 1 Then
        mListCount = objBox.ListCount
    End If
    
    objBox.Visible = False
    
    'Font objDestination save
    FontSaveFont objDestination, FontSave
    'Font der Box zuweisen
    FontSetFont objDestination, objBox
    'Restore Font
    
    objBox.AddItem BoxSetItemRightAlign(objDestination, _
                        objBox, NewItem, mListCount, DigitCount)
    objBox.ItemData(objBox.NewIndex) = ItemData
  
    FontRestoreFont objDestination, FontSave
    objBox.Visible = True
End Sub

Private Function BoxSetItemRightAlign(objDestination As Object, _
        objBox As Object, sString As String, ListCount As Long, _
        Optional DigitCount As Long = 0) As String
        
    'liefert ein Item in  List- oder Combobox rechtsbndig ausgerichtet
    
    Dim s As String
    Dim w As Single, w1 As Single
    Dim h As Single, h1 As Single
    Dim WithScroll As Boolean
    Dim AnzSpace As Long
    
    'hat die objBox einen Scrollbalken oder ist Combo
    h = objBox.Height - 60
    h1 = objDestination.TextHeight(s) * ListCount
    If (h1 > h) Or (TypeOf objBox Is ComboBox) Then
        WithScroll = True
    End If
    
    'Imtem laden
    s = Trim(sString)
    
    'Breite feststellen
    w = objDestination.TextWidth(s)
    
    'Boxbreite festellen oder Breite nach Anzahl Digits
    If DigitCount > 0 Then
        w1 = objDestination.TextWidth(String$(DigitCount, "0"))
        
        'den Scrollbalken bercksichtigen
        If (TypeOf objBox Is ComboBox) Or WithScroll Then
            w1 = w1 + 285
        End If
    Else
        If TypeOf objBox Is ComboBox Then
            w1 = objBox.Width - 105
        Else
            w1 = objBox.Width - 135
        End If
    End If
    
    'hat die objBox einen Scrollbalken oder ist Combo
    If WithScroll Then
        w1 = w1 - 285
    End If
    
    'vorlaufende Spaces ausrechnen
    If objDestination.FontBold Or objDestination.FontItalic Then
        
        'eigenartiges Verhalten bei Bold und Italic
        Do While objDestination.TextWidth(s & Space$(1)) < w1
            s = Space(1) & s
        Loop
    Else
        If w1 < w Then
            w1 = w
        End If
        AnzSpace = (w1 - w) \ objDestination.TextWidth(Space$(1))
        s = Space$(AnzSpace) & s
    End If
    
    'liefert den String
    BoxSetItemRightAlign = s
End Function

Public Sub FontSaveFont(SourceObject As Object, _
           FontSave As FontSaveType)
    'bergibt in eine Variable vom Typ FontSaveType den Font
    'eines QuellObjects
    
    With FontSave
        .FontName = SourceObject.FontName
        .FontSize = SourceObject.FontSize
        .FontItalic = SourceObject.FontItalic
        .FontUnderline = SourceObject.FontUnderline
        .FontStrikethru = SourceObject.FontStrikethru
    End With
End Sub

Public Sub FontRestoreFont(DestinationObject As Object, _
           FontSave As FontSaveType)
    'stellt im Destination Object den ber FontSaveFont gepeicherten
    'Font Zustand wieder her

    With FontSave
        DestinationObject.FontName = .FontName
        DestinationObject.FontSize = .FontSize
        DestinationObject.FontItalic = .FontItalic
        DestinationObject.FontUnderline = .FontUnderline
        DestinationObject.FontStrikethru = .FontStrikethru
    End With

End Sub

Public Sub FontSetFont(objDestination As Object, objSource As Object)
    'Font eines Objects (List-/Combobox) bergeben an Form, Picbox, Printer

    With objDestination
        .FontName = objSource.FontName
        .FontSize = objSource.FontSize
        .FontBold = objSource.FontBold
        .FontItalic = objSource.FontItalic
        .FontUnderline = objSource.FontUnderline
        .FontStrikethru = objSource.FontStrikethru
    End With
End Sub


